const
  _6845_Index = $3D4 ;
  _6845_Data  = $3D5 ;
  ModeControl = $3D8 ;
  MaxC        = 6 ;

var
  c         :char ;
  screen    : array[0..7999,0..1] of byte absolute $B000:$8000 ;
  screeni   : array[0..7999] of integer absolute $B000:$8000 ;
  hue       : array[0..MaxC,0..MaxC,0..MaxC] of byte ;
  inten     : array[0..MaxC,0..MaxC,0..MaxC] of byte ;
  block     : array[1..18,1..22] of integer ;
  colorfile : file of byte ;
  blockfile : file of integer ;
  box,boy   : integer ;

procedure SetColors ;
var
  r,g,b : integer ;
begin
  assign(colorfile,'COLOR.DAT');
  reset(colorfile) ;
  for r := 0 to MaxC do
  begin
    for g := 0 to MaxC do
    begin
      for b := 0 to MaxC do
      begin
        read(colorfile,hue[r,g,b]   );
        read(colorfile,inten[r,g,b])  ;
      end ;
    end ;
  end ;
  Close(ColorFile) ;
end ;

procedure GetBlock ;
var
  i,j : integer ;
begin
  assign(blockfile,'CUBE.DAT') ;
  reset(blockfile) ;
  for i := 1 to 18 do
    for j := 1 to 14 do
    BEGIN
      read(blockfile,block[i,j]) ;
    END ;
  close(Blockfile) ;
  boy := 82 ;
  box := 0 ;
end ;

procedure VideoReg(reg,data:integer) ;
begin
  Port[_6845_Index]:=reg ;
  Port[_6845_Data] :=data;
end ;

procedure NoBlink ;
begin
  Port[ModeControl] := 9 ;
end ;

procedure MultiColor ;
begin
  SetColors ;
  TextMode(C80) ; {put into 80 colomn color mode}
  VideoReg(4,$7F); {increase total lines to 255}
  VideoReg(6,$64); {increase displayed lines to 200}
  VideoReg(7,$70); {change sync position}
  VideoReg(9,$03); {change to 4 scan lines high}
  NoBlink ;
end ;

procedure NormalColor ;
begin
  TextMode(C40) ;
  TextMode(C80) ;
end ;

procedure Beep ;
begin
  Sound(2000) ;
  Delay(500) ;
  NoSound ;
end ;

function Shade(c:integer;n:real):integer ;
var
  sh : integer ;
begin
  Sh := c+round(abs((MaxC/2)-c)*n) ;
  if (sh<0) then shade := 0 else
  if (sh>MaxC) then shade:=MaxC else
  shade := sh ;
end ;


procedure drawblock(red,grn,blu,origx,origy:integer) ;
const
  ds = -0.3 ;
  l : integer = 0 ;
var
  x,y,h,i : integer ;
  shd: array[0..2] of integer ;
begin
  for x := 0 to 2 do
  begin
    h := hue[shade(red,ds*x),shade(grn,ds*x),shade(blu,ds*x)] ;
    i := inten[shade(red,ds*x),shade(grn,ds*x),shade(blu,ds*x)] ;
    shd[x] := i+256*h ;
  end ;
  if not((shd[0]=shd[1]) or (shd[0]=shd[2]) or (shd[1]=shd[2])) then
  begin
    for y := 1 to 18 do
      for x := 1 to 14 do
      begin
        if block[y,x]>=0 then screeni[(origx+x)+80*(origy+y)] := shd[block[y,x]];
      end ;
    ;
    box := box+9 ;
    if box>65 then
    begin
      l := (l+1) mod 4 ;
      box:=0 + l  ;
      boy := boy-14;
      if boy<-2 then
      begin
        boy:=82 ;
      end ;
    end ;
  end ;
end ;


procedure FillColor ;
var
  i,x,y,z :integer ;
  red,grn,blu : integer ;
  x2,y2 : integer ;
  co,ch : byte ;
begin
  for i := 0 to 7999 do
  begin
    Screen[i,0] := inten[1,1,1] ;
    Screen[i,1] := hue[1,1,1] ;
  end ;
  for grn := MaxC downto 0 do
    for blu := 0 to MaxC do
      for red := 0 to MaxC do
      begin
        drawblock(red,grn,blu,box,boy) ;
      end ;
   ;
 ;
end ;

BEGIN
  GetBlock ;
  Multicolor ;
  FillColor ;
  Beep ;
  read(kbd,c) ;
  NormalColor ;
END.
